﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using DotNETWork;
using DotNETWork.Globals;
using DotNETWork.Security;
using DotNETWork.Tcp;
using System.Threading;
using System.Diagnostics;

namespace ClientExampleDotNETWork
{
    public partial class Client : Form
    {
        public Client()
        {
            InitializeComponent();
        }

        private DotTcpClient dotTcpClient;


        private bool startedAnalyzing, isTyping;
        private Stopwatch stopWatch = new Stopwatch();
        
        private Random randomInt = new Random();

        private void Client_Load(object sender, EventArgs e)
        {

            string inputString = Microsoft.VisualBasic.Interaction.InputBox("Type in ip and port (Scheme: ip:port)");

            string serverIp = inputString.Split(':')[0];
            int serverPort = int.Parse(inputString.Split(':')[1]);

            dotTcpClient = new DotTcpClient(serverIp, serverPort);

            if (!dotTcpClient.Connect(1000))
            {
                MessageBox.Show("Connection refused!", "Message", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly);

                tbInput.Enabled = false;

                return;
            }

            pbAvatar.Image = new Bitmap(1, 1);

            // Eindeutige ID , damit das Avatar und der Status des Schreibens an den Sender erneut verschickt werden.
            string clientId = "Id_" + randomInt.Next(0, 1000);

            dotTcpClient.Send("$$$USER=" + clientId);
            //dotTcpClient.Send("$$$AVATAR");
            //dotTcpClient.Send(pbAvatar.Image);
 

            new Thread(new ThreadStart(() =>
            {
                while (true)
                {

                    string messageIn = dotTcpClient.Receive();
                    if (messageIn.Contains("$$§$$CMD"))
                    {
                      
                        this.Invoke(new Action(() =>
                        {
                            statusLb.Text = "Status " + (messageIn.Split('=')[1].Equals("TRUE") ? "is writing..." : "idle");
                        }));
                    }
                    //else if (messageIn.Contains("$$$AVATAR"))
                    //{
                         
                    //    this.Invoke(new Action(() =>
                    //    {
                    //        pbAvatar.Image = (Image)dotTcpClient.Receive();
                    //    }));
                    //}
                    else
                        this.Invoke(new Action(() =>
                        {
                            receivingLb.Items.Add(messageIn);
                        }));

                }
            })).Start();

        }

        private void tbInput_KeyDown(object sender, KeyEventArgs e)
        {
            if (!startedAnalyzing)
            {
                startedAnalyzing = true;
                Task.Run(() =>
                {
                    dotTcpClient.Send("$$§$$CMD_WRITING=TRUE");
                    while (startedAnalyzing)
                    {
                        if (isTyping)
                        {
                            stopWatch.Reset();
                            stopWatch.Start();
                        }
                        else
                        {
                            if (stopWatch.Elapsed.TotalMilliseconds >= 500)
                            {
                                break;
                            }
                        }
                        new ManualResetEvent(false).WaitOne(1);
                    }

                    startedAnalyzing = false;
                    dotTcpClient.Send("$$§$$CMD_WRITING=FALSE");

                });
            }


            if (e.KeyCode == Keys.Enter && !isTyping)
            {
                sendBttn.PerformClick();
                e.SuppressKeyPress = true;
            }
            isTyping = true;
        }

        private void tbInput_KeyUp(object sender, KeyEventArgs e)
        {
            isTyping = false;
        }

        private void sendBttn_Click(object sender, EventArgs e)
        {
            dotTcpClient.Send(tbInput.Text);
            tbInput.Clear();
        }
    }

    public static class Extension
    {
        public static void InvokeI(this Form frm, Action aDelegate)
        {
            frm.Invoke(aDelegate);
        }
    }
}
