﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using DotNETWork.Tcp;
using System.Drawing;
using System.Net.Sockets;
using System.IO;
using System.Net;
using System.Threading;
using DotNETWork.Udp;
using DotNETWork.Globals;
using DotNETWork.Udp.ACK;
using DotNETWork.Security;
namespace TestingDotNETWork
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.Write("Port: ");
            DotTcpServer<User> tcpServer = new DotTcpServer<User>(int.Parse(Console.ReadLine()));
            tcpServer.MaximumClients = 2;
            tcpServer.Run();
            Console.WriteLine("Server is running!");
        }
    }

    public class User : IClient
    {
        public IPEndPoint ClientEndPoint { get; set; }
        public TcpClient TcpClient { get; set; }

        public BinaryReader BinReader { get; set; }
        public BinaryWriter BinWriter { get; set; }

        public string PublicKeyXML { get; set; }

        DotRijndaelEncryption rEncryptor;

        private string UserId;

        public void Call(object parameter)
        {
            ClientParameters<User> clientParameters = (ClientParameters<User>)parameter;

            try
            {
                string text = clientParameters.DecryptedBytes.DeserializeToDynamicType();
                if (text.Contains("$$$USER"))
                {
                    this.UserId = text.Split(new char[]
					{
						'='
					})[1];
                }
                else if (text.Contains("$$§$$CMD"))
                {
                    User user = clientParameters.ServerHandler.ClientList.Find((User p) => p.UserId != this.UserId);
                    this.rEncryptor = new DotRijndaelEncryption(user.PublicKeyXML);
                    byte[] array = this.rEncryptor.EncryptStream(clientParameters.DecryptedBytes);
                    user.BinWriter.Write(array.Length);
                    user.BinWriter.Write(array);
                }
                else
                {
                    for (int i = 0; i < clientParameters.ServerHandler.ClientList.Count; i++)
                    {
                        this.rEncryptor = new DotRijndaelEncryption(clientParameters.ServerHandler.ClientList[i].PublicKeyXML);
                        byte[] array2 = this.rEncryptor.EncryptStream(clientParameters.DecryptedBytes);
                        clientParameters.ServerHandler.ClientList[i].BinWriter.Write(array2.Length);
                        clientParameters.ServerHandler.ClientList[i].BinWriter.Write(array2);
                    }
                }
                Console.WriteLine("Received..!");
            }
            catch (Exception ex)
            {
                Console.WriteLine("Error...!" + ex.Message);
            }
        }
    }
}